                MEMBER

WM_SIZE         EQUATE(0005h)
WM_SETFOCUS     EQUATE(0007h)
WM_KILLFOCUS    EQUATE(0008h)
SWP_NOZORDER    EQUATE(0004h)
GWL_STYLE       EQUATE(-16)

! SetWindowPos() hwndInsertAfter field values           !!!NOT SURE ABOUT THESE
HWND_TOP        EQUATE(0)
HWND_BOTTOM     EQUATE(1)
HWND_NOTOPMOST  EQUATE(-2)

WS_BORDER_NOT   EQUATE(0ff7fffffh)
WS_DLGFRAME_NOT EQUATE(0ffbfffffh)


RECT            GROUP,TYPE
left            SIGNED
top             SIGNED
right           SIGNED
bottom          SIGNED
 END

               INCLUDE('coobj.inc'),ONCE

                MAP
                 MODULE('')
                  IsWindowVisible(UNSIGNED),BOOL,PASCAL
                  GetWindowRect(UNSIGNED, *RECT),PASCAL,RAW
                  GetClientRect(UNSIGNED, *RECT),PASCAL,RAW
                  SetWindowLong(UNSIGNED,SIGNED,LONG),LONG,PASCAL,NAME('SetWindowLongA'),proc
                  GetWindowLong(UNSIGNED,SIGNED),LONG,PASCAL,NAME('GetWindowLongA'),proc
                  SetWindowPos(UNSIGNED, UNSIGNED, SIGNED, SIGNED, SIGNED, SIGNED, UNSIGNED),BOOL,PASCAL,PROC
                 END
                END

 omit('***')
 include('traceers.inc'),once
liblog          class(traceers)
construct       procedure()
 end
liblog.construct        procedure
        code
 self.init('FRAME')
 remove(self.log)
 !***

!---------------------------------------------------------------------
COFRAME.Construct               PROCEDURE
        CODE
  SELF.Q &= NEW QCOFRAME
!---------------------------------------------------------------------
COFRAME.Destruct                PROCEDURE
        CODE
 SELF.CloseWindow()
 DISPOSE(SELF.Q)

!---------------------------------------------------------------------
COFRAME.CloseWindow             PROCEDURE
I       LONG
        CODE
 LOOP I = 1 TO RECORDS(SELF.Q)
  GET(SELF.Q,I)
  SELF.Q.object.Kill
  DISPOSE(SELF.Q.object)
 END
 FREE(SELF.Q)

!---------------------------------------------------------------------
COFRAME.Init                    PROCEDURE(Window W)
        CODE
 SELF.InitSubProc(W{PROP:ClientHandle})

!---------------------------------------------------------------------
COFRAME.AddWindow               PROCEDURE(Window W)
hWnd    UNSIGNED
tmp     LONG
        CODE
 W{PROP:NoFrame} = True

 hWnd = W{PROP:Handle}

 !tmp = GetWindowLong(hWnd,GWL_STYLE)
 !tmp = BAND(tmp,WS_BORDER_NOT)
 !tmp = BAND(tmp,WS_DLGFRAME_NOT)
 !SetWindowLong(hWnd,GWL_STYLE,tmp)

 CLEAR(SELF.Q)
 SELF.Q.hWnd    = W{PROP:Handle}
 SELF.Q.object &= NEW COMDI
 SELF.Q.object.Init(SELF)
 ADD(SELF.Q)

 SELF.Q.object.Init(SELF.Handle,SELF.Q.hWnd)

!---------------------------------------------------------------------
COFRAME.DelWindow               PROCEDURE(Window W)
        CODE
 SELF.Q.hWnd = W{PROP:Handle}
 GET(SELF.Q,SELF.Q.hWnd)
 IF NOT ERRORCODE()
  SELF.Q.object.Kill
  DISPOSE(SELF.Q.object)
 END
 DELETE(SELF.Q)

!---------------------------------------------------------------------
COFRAME.ProcessMessage          FUNCTION(UNSIGNED hWnd,UNSIGNED uMsg, UNSIGNED wParam, LONG lParam)
ret     LONG
        CODE

 ret = PARENT.ProcessMessage(hWnd,uMsg,wParam,lParam)

 CASE uMsg
  OF WM_SIZE
   Do SizedRoutine
 END

 RETURN ret

SizedRoutine    ROUTINE

 SELF.Q.hWnd = SELF.focus
 GET(SELF.Q,SELF.Q.hWnd)
 IF NOT ERRORCODE()
  SELF.Q.object.Sized()
 END

!---------------------------------------------------------------------
!---------------------------------------------------------------------
COMDI.Init                      PROCEDURE(COFRAME Base)
        CODE
 SELF.Base &= Base

!---------------------------------------------------------------------
COMDI.Init                      PROCEDURE(UNSIGNED hFrameWnd,UNSIGNED hWnd)
tmp     LIKE(RECT)
rec     LIKE(RECT)
        CODE

 SELF.hFrameWnd = hFrameWnd

 GetWindowRect(hWnd,tmp)
 GetClientRect(hWnd,rec)

 SELF.Left   = (tmp.Right  - tmp.Left - rec.Right) / 2
 SELF.Right  = SELF.Left
 SELF.Top    = tmp.Bottom - tmp.Top - rec.Bottom - SELF.Left
 SELF.Bottom = SELF.Right

 SELF.InitSubProc(hWnd)

 SELF.Sized()

!---------------------------------------------------------------------
COMDI.Sized                     PROCEDURE
tmp     LIKE(RECT)
        CODE

 GetClientRect(SELF.hFrameWnd,tmp)

 tmp.Top     = -SELF.Top
 tmp.Left    = -SELF.Left
 tmp.Bottom += SELF.Bottom
 tmp.Right  += SELf.Right

 SetWindowPos(SELF.Handle,HWND_BOTTOM,|
     tmp.Left,tmp.Top,|
      tmp.Right - tmp.Left, |
       tmp.Bottom - tmp.Top,|
        SWP_NOZORDER)

!---------------------------------------------------------------------
COMDI.ProcessMessage            FUNCTION(UNSIGNED hWnd,UNSIGNED uMsg, UNSIGNED wParam, LONG lParam)
ret     LONG
        CODE

 ret = PARENT.ProcessMessage(hWnd,uMsg,wParam,lParam)

 CASE uMsg
  OF WM_KILLFOCUS
  OF WM_SETFOCUS
   SELF.Base.focus = SELF.Handle
   SELF.Sized()
 END

 RETURN ret
